/* maximum post request length in bytes (or number of char)*/
/* By default, httpd limit is connection max body 1M */
/* #define MAXLEN 524288 */

#define		MAXLEN 256
#define		CAPTCHALEN 24
#define		MAXWAIT 5

/* Directory where requests are stored.
 * Remember httpd is chrooted in /var/www, so
 * /var/www is / actually
 */
static const char *chpw_requests_dir = "/tabr_chpw_requests";

/* captcha config */
enum 		{ DIGIT, LOWER, UPPER, PUNCT };
/* instructions displayed for humans, same order as above! */
static const char *instructions[] = {
	"Recopiez uniquement les chiffres",
	"Recopiez uniquement les lettres minuscules",
	"Recopiez uniquement les lettres majuscules",
	"Recopiez uniquement les symboles et ponctuation",
};

/* form displayed. Look at %s for antispam */
static const char *form = 
"<!DOCTYPE html>\n"
"<html>\n"
"<head>\n"
"<meta name=\"viewport\" content=\"width=device-width\" />\n"
"<meta charset=\"utf-8\">\n"
"<meta http-equiv=\"Cache-Control\" content=\"no-cache, no-store, must-revalidate\">\n"
"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"
"<meta http-equiv=\"Expires\" content=\"0\">\n"
"<link rel=\"icon\" href=\"data:,\">\n"
"<style type=\"text/css\">\n"
"*{box-sizing:border-box;max-width:100%%}\n"
"body{font:1.1rem/1.4 sans-serif;max-width:42rem;margin:auto; padding:1rem}\n"
"input{font-family:monospace;width:100%%;"
"font-size:1.3rem; margin:auto auto 1.5rem auto}\n"
"input:valid{background-color:rgba(0,204,0,.25)}\n"
"input:invalid{background:-colorrgba(255,0,0,.25)}\n"
"button{width:50%%;border:1px solid silver;\n"
"background-color:steelblue;color:white;\n"
"padding:15px 32px;text-decoration: none;\n"
"display:inline-block;cursor:pointer;\n"
"font-size:x-large;}\n"
"button:hover{opacity:.8}\n"
"label{font-weight:bold;font-size:larger}\n"
".center{text-align:center}\n"
"</style>\n"
"<title>Formulaire de changement de mot de passe</title>\n"
"</head>\n"
"<body>\n"
"<h1>Changement de mot de passe</h1>\n"
"<form method=\"post\" action=\"?\" >\n"
"<hr />\n"
"<div>\n"
"<p><label for=\"user\">Utilisateur:</label>\n"
"<input type=\"text\" name=\"user\" id=\"user\""
" placeholder=\"Paul\" required"
" title=\"Peut contenir des lettres minuscules, des chiffres, "
" des points, tirets, underscores."
" Ne doit pas commencer par un tiret. "
" Entre 1 et 31 caractères\""
" pattern=\"^[a-z0-9_\\.][a-z0-9_\\.\\-]{1,30}$\" />\n"
"</div>\n"
"<div>\n"
"<p><label for=\"recovery\">Code de récupération:</label>\n"
"<input type=\"text\" name=\"recovery\" id=\"recovery\""
" placeholder=\"CHANI1-IDAHO2-ATREID-DUNE34-SIETCH\" required /></p>\n"
"</div>\n"
"<div>\n"
"<p><label for=\"newpass\">Nouveau mot (phrase) de passe:</label>\n"
"<input type=\"password\" name=\"newpass\" id=\"newpass\""
" placeholder=\"Respirer de la compote fait tousser\""
" title=\"15 caractères minimum\""
" minlength=\"15\" required /></p>\n"
"</div>\n"
"<div>\n"
"<p><label for=\"answer\">Anti-pirate: </label>%s</p>\n"
"<pre class= \"center\">%s</pre>\n"
"<input type=\"text\" name=\"answer\" id=\"answer\" required />\n"
"</div>\n"
"<div>\n"
"<input type=\"hidden\" name=\"anshash\" id=\"anshash\" value=\"%s\" />\n"
"</div>\n"
"<div class=\"center\">\n"
"<button name=\"action\" value=\"validate\" type=\"submit\">Valider</button>\n"
"</div>\n"
"</form>\n"
"</body>\n"
"</html>";

/* html message displayed when a form is submitted successfully */
static const char *okform = 
"<!doctype html>\n\n"
"<html>\n"
"<head>\n"
"<meta charset=\"utf-8\">\n"
"<meta name=\"viewport\" content=\"width=device-width\">\n"
"<style type=\"text/css\">\n"
"*{box-sizing:border-box;max-width:100%%}\n"
"body{font:1.1rem/1.4 sans-serif;max-width:42rem;margin:auto; padding:1rem}\n"
"</style>\n"
"<title>Demande bien enregistrée</title>\n"
"</head>\n"
"<body><main>\n"
"<p>Demande bien reçue. ✌️</p>\n"
"<p>Elle sera traitée dans les prochaines minutes</p>\n"
"</main></body>\n"
"</html>";

static const char *valid_username_regex = "^[a-z0-9_\\.][a-z0-9_\\.\\-]{1,30}$";

/* error messages */
static const char *errcaptcha = "Mauvaise réponse! 😱";
static const char *errusername = "Mauvais format. Le nom d'utilisateur doit avoir une longueur entre 1 et 31 caractères, ne peut pas commencer par un \"-\" et ne peut contenir que les symboles suivants: \"abcdefghijklmnopqrstuvwxyz0123456789-_.\"";
static const char *errshortpw = "Mot de passe trop court : au moins 15 caractères sont attendus. Une phrase peut fonctionner.";
